/* QuesoGLC
 * A free implementation of the OpenGL Character Renderer (GLC)
 * Copyright (c) 2002, 2004-2007, Bertrand Coconnier
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2.1 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* $Id: ofacedesc.h,v 1.11 2007/02/18 16:50:58 bcoconni Exp $ */

/** \file
 * header of the object __glcFaceDesc that contains the description of a face.
 */

#ifndef __glc_ofacedesc_h
#define __glc_ofacedesc_h

#include "ocharmap.h"

typedef struct __GLCfaceDescriptorRec __GLCfaceDescriptor;

struct __GLCfaceDescriptorRec {
  FT_ListNodeRec node;
  FcChar8* styleName;
  GLboolean isFixedPitch;	/* GLC_IS_FIXED_PITCH */
  FcChar8* fileName;
  FT_Long indexInFile;
#ifndef FT_CACHE_H
  FT_Face face;
  int faceRefCount;
#endif
  FT_ListRec glyphList;
};


__GLCfaceDescriptor* __glcFaceDescCreate(FcChar8* inStyleName,
					 GLboolean inIsFixedPitch,
					 FcChar8* inFileName,
					 FT_Long inIndexInFile);
void __glcFaceDescDestroy(__GLCfaceDescriptor* This,
			  __GLCcontext* inContext);
#ifndef FT_CACHE_H
FT_Face __glcFaceDescOpen(__GLCfaceDescriptor* This,
			  __GLCcontext* inContext);
void __glcFaceDescClose(__GLCfaceDescriptor* This);
#endif
__GLCglyph* __glcFaceDescGetGlyph(__GLCfaceDescriptor* This, GLint inCode,
				  __GLCcontext* inContext);
FT_Face __glcFaceDescLoadFreeTypeGlyph(__GLCfaceDescriptor* This,
			       __GLCcontext* inContext, GLfloat inScaleX,
			       GLfloat inScaleY, FT_ULong inGlyphIndex);
void __glcFaceDescDestroyGLObjects(__GLCfaceDescriptor* This,
				   __GLCcontext* inContext);
__GLCcharMap* __glcFaceDescGetCharMap(__GLCfaceDescriptor* This,
				      __GLCcontext* inContext);
GLfloat* __glcFaceDescGetBoundingBox(__GLCfaceDescriptor* This,
				     FT_ULong inGlyphIndex, GLfloat* outVec,
				     GLfloat inScaleX, GLfloat inScaleY,
				     __GLCcontext* inContext);
GLfloat* __glcFaceDescGetAdvance(__GLCfaceDescriptor* This,
				 FT_ULong inGlyphIndex, GLfloat* outVec,
				 GLfloat inScaleX, GLfloat inScaleY,
				 __GLCcontext* inContext);
FcChar8* __glcFaceDescGetFontFormat(__GLCfaceDescriptor* This,
				    __GLCcontext* inContext,
				    GLCenum inAttrib);
GLfloat* __glcFaceDescGetMaxMetric(__GLCfaceDescriptor* This, GLfloat* outVec,
				   __GLCcontext* inContext);
GLfloat* __glcFaceDescGetKerning(__GLCfaceDescriptor* This,
				 FT_UInt inGlyphIndex, FT_UInt inPrevGlyphIndex,
				 GLfloat inScaleX, GLfloat inScaleY,
				 GLfloat* outVec, __GLCcontext* inContext);
#endif /* __glc_ofacedesc_h */
